unit UHook;

interface
uses
  ShlObj, ComObj, Windows;

const
  CLSID_WEHook:TGUID='{9C123760-65F8-11D2-AEF9-444553540000}';
type
  TWEHook=class(TComObject,ICopyHook)
  public
    function CopyCallback(Wnd: HWND; wFunc, wFlags: UINT;
          pszSrcFile: PAnsiChar; dwSrcAttribs: DWORD; pszDestFile:
          PAnsiChar; dwDestAttribs: DWORD): UINT; stdcall;
  end;

implementation
  uses Dialogs, Forms, ShellAPI, SysUtils, ComServ;

type
  TWEHookFactory=class(TComObjectFactory)
  public
    procedure UpdateRegistry(Register: Boolean); override;
  end;

function TWEHook.CopyCallback(Wnd: HWND; wFunc, wFlags: UINT; pszSrcFile: PAnsiChar; dwSrcAttribs: DWORD;
  pszDestFile: PAnsiChar; dwDestAttribs: DWORD): UINT;
var
  Msg:string;
begin
  Application.Handle:=Wnd;
  Msg:='';
  case WFunc of
    FO_COPY:   Msg:=Format('      %s  %s?',[pszSrcFile,pszDestFile]);
    FO_DELETE: Msg:=Format('      %s?',[pszSrcFile]);
    FO_MOVE:   Msg:=Format('      %s  %s?',[pszSrcFile,pszDestFile]);
    FO_RENAME: Msg:=Format('      %s  %s?', [pszSrcFile,pszDestFile]);
  end;
  if length(Msg)>0 then
    Result:=MessageDlg(Msg,mtConfirmation,[mbYes,mbNo, mbCancel],0)
  else
    Result:=id_Yes;
end;

procedure TWEHookFactory.UpdateRegistry(Register: Boolean);
begin
  if Register then
  begin
    CreateRegKey('Directory\shellex\CopyHookHandlers\WEHook','',GUIDToString(CLSID_WEHook));
    CreateRegKey('CLSID\'+GUIDToString(CLSID_WEHook)+ '\InprocServer32','ThreadingModel','Apartment');
    inherited UpdateRegistry(Register);
  end
  else
  begin
     DeleteRegKey('Directory\shellex\CopyHookHandlers\WEHook');
     inherited UpdateRegistry(Register);
  end;
end;

initialization
  TWEHookFactory.Create(ComServer,TWEHook,CLSID_WEHook,'WEHook','WEFolder Test Hook',ciMultiInstance);

end.
